# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.OSLogin.V1.Model.PosixAccount do
  @moduledoc """
  The POSIX account information associated with a Google account.

  ## Attributes

  *   `accountId` (*type:* `String.t`, *default:* `nil`) - Output only. A POSIX account identifier.
  *   `gecos` (*type:* `String.t`, *default:* `nil`) - The GECOS (user information) entry for this account.
  *   `gid` (*type:* `String.t`, *default:* `nil`) - The default group ID.
  *   `homeDirectory` (*type:* `String.t`, *default:* `nil`) - The path to the home directory for this account.
  *   `name` (*type:* `String.t`, *default:* `nil`) - Output only. The canonical resource name.
  *   `operatingSystemType` (*type:* `String.t`, *default:* `nil`) - The operating system type where this account applies.
  *   `primary` (*type:* `boolean()`, *default:* `nil`) - Only one POSIX account can be marked as primary.
  *   `shell` (*type:* `String.t`, *default:* `nil`) - The path to the logic shell for this account.
  *   `systemId` (*type:* `String.t`, *default:* `nil`) - System identifier for which account the username or uid applies to. By default, the empty value is used.
  *   `uid` (*type:* `String.t`, *default:* `nil`) - The user ID.
  *   `username` (*type:* `String.t`, *default:* `nil`) - The username of the POSIX account.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :accountId => String.t() | nil,
          :gecos => String.t() | nil,
          :gid => String.t() | nil,
          :homeDirectory => String.t() | nil,
          :name => String.t() | nil,
          :operatingSystemType => String.t() | nil,
          :primary => boolean() | nil,
          :shell => String.t() | nil,
          :systemId => String.t() | nil,
          :uid => String.t() | nil,
          :username => String.t() | nil
        }

  field(:accountId)
  field(:gecos)
  field(:gid)
  field(:homeDirectory)
  field(:name)
  field(:operatingSystemType)
  field(:primary)
  field(:shell)
  field(:systemId)
  field(:uid)
  field(:username)
end

defimpl Poison.Decoder, for: GoogleApi.OSLogin.V1.Model.PosixAccount do
  def decode(value, options) do
    GoogleApi.OSLogin.V1.Model.PosixAccount.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.OSLogin.V1.Model.PosixAccount do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
