# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.OSLogin.V1alpha.Model.ImportSshPublicKeyResponse do
  @moduledoc """
  A response message for importing an SSH public key.

  ## Attributes

  *   `details` (*type:* `String.t`, *default:* `nil`) - Detailed information about import results.
  *   `loginProfile` (*type:* `GoogleApi.OSLogin.V1alpha.Model.LoginProfile.t`, *default:* `nil`) - The login profile information for the user.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :details => String.t() | nil,
          :loginProfile => GoogleApi.OSLogin.V1alpha.Model.LoginProfile.t() | nil
        }

  field(:details)
  field(:loginProfile, as: GoogleApi.OSLogin.V1alpha.Model.LoginProfile)
end

defimpl Poison.Decoder, for: GoogleApi.OSLogin.V1alpha.Model.ImportSshPublicKeyResponse do
  def decode(value, options) do
    GoogleApi.OSLogin.V1alpha.Model.ImportSshPublicKeyResponse.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.OSLogin.V1alpha.Model.ImportSshPublicKeyResponse do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
