# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.OSLogin.V1alpha.Model.SshPublicKey do
  @moduledoc """
  The SSH public key information associated with a Google account.

  ## Attributes

  *   `expirationTimeUsec` (*type:* `String.t`, *default:* `nil`) - An expiration time in microseconds since epoch.
  *   `fingerprint` (*type:* `String.t`, *default:* `nil`) - Output only. The SHA-256 fingerprint of the SSH public key.
  *   `key` (*type:* `String.t`, *default:* `nil`) - Public key text in SSH format, defined by RFC4253 section 6.6.
  *   `name` (*type:* `String.t`, *default:* `nil`) - Output only. The canonical resource name.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :expirationTimeUsec => String.t() | nil,
          :fingerprint => String.t() | nil,
          :key => String.t() | nil,
          :name => String.t() | nil
        }

  field(:expirationTimeUsec)
  field(:fingerprint)
  field(:key)
  field(:name)
end

defimpl Poison.Decoder, for: GoogleApi.OSLogin.V1alpha.Model.SshPublicKey do
  def decode(value, options) do
    GoogleApi.OSLogin.V1alpha.Model.SshPublicKey.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.OSLogin.V1alpha.Model.SshPublicKey do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
